.386
.model flat, stdcall
option casemap:none

import		PROTO :DWORD
do_relocation	PROTO :DWORD

include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc
include	\masm32\include\user32.inc
include	\masm32\include\masm32.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\masm32.lib

extern pFile:BYTE

.data

caption1	db 'Chetnik',39,'s pe-mem demo',0
msg1	db 'Testing dialog.exe...',0
msg2	db 'dialog.exe terminated',0	

.data?

exeptr	dd    ?       ;pointer to PE in memory
nthdr	IMAGE_NT_HEADERS32 <?>
entry	dd    ?       ;<---- new entry point!!! =)

.code
start:

   mov esi,OFFSET pFile
   add esi, [esi+3ch]                    ;<--- go to PE...
   ; copy to nthdr struct
   mov edi, offset nthdr
   mov ecx, sizeof IMAGE_NT_HEADERS32
   cld 
   rep movsb                                
   
   ; Allocate memory for image --- random address we don't care...
   ; B/C we want to execute our code from any given location...
   invoke VirtualAlloc, NULL,  nthdr.OptionalHeader.SizeOfImage, \
                               MEM_COMMIT, PAGE_EXECUTE_READWRITE
   mov exeptr, eax
   
   add eax, nthdr.OptionalHeader.AddressOfEntryPoint
   mov entry, eax              ;<---- Here is out new entry point =) 
                               
  
   ; Copy Headers to exeptr (our virtual-pe-exe =))
   mov esi,OFFSET pFile
   mov edi, exeptr
   mov ecx, nthdr.OptionalHeader.SizeOfHeaders
   cld
   rep movsb
   
   mov ebx,OFFSET pFile
   add ebx, [ebx+3ch]
   add ebx, sizeof IMAGE_NT_HEADERS32  ;<---ebx points to the first section struct
                                       ;<---copy all section to the right place in
                                       ;<--- virtual-exe
    ASSUME ebx : ptr IMAGE_SECTION_HEADER                                    
   
   xor ecx, ecx                                    
   mov cx, nthdr.FileHeader.NumberOfSections
   ;<------- Copy all sections to memory
   @@:
     mov esi, [ebx].PointerToRawData
     add esi,OFFSET pFile
     mov edi, [ebx].VirtualAddress
     add edi, exeptr
     push ecx
     mov ecx, [ebx].SizeOfRawData
     cld
     rep movsb
     pop ecx
     add ebx, sizeof IMAGE_SECTION_HEADER
   loop @B
   ;<--------- All sections are copied to right addresses
   ;<--------- Find import and Make adjustments
   mov ebx, nthdr.OptionalHeader.DataDirectory[1*8].VirtualAddress
   add ebx, exeptr
   
   invoke import, ebx
   ;<---- IAT is ready to go, now we have to do relocations...
   ;<---- Yap nice and smooth relocations...
   mov ebx, nthdr.OptionalHeader.DataDirectory[5*8].VirtualAddress
   add ebx, exeptr       ;<------- Relocation Table...
   
   invoke do_relocation, ebx
   
   invoke MessageBox,0,ADDR msg1,ADDR caption1,MB_OK 
   
   call entry

   invoke MessageBox,0,ADDR msg2,ADDR caption1,MB_OK

   invoke ExitProcess, NULL
   
import PROC iides:DWORD
    LOCAL dllHandle:DWORD
    LOCAL api:DWORD
    
    mov ebx, iides
    ;BIG LOOPING
    ASSUME ebx : ptr IMAGE_IMPORT_DESCRIPTOR
    fill_import: 
    ;<---- loop trough image import Descriptor
    ;<---- Load Library for e\ch IMAGE_IMPORT_DESCRIPTOR
      mov esi, [ebx].Name1
      add esi, exeptr
      invoke LoadLibrary, esi
      mov dllHandle, eax
      mov edx, [ebx].OriginalFirstThunk
      add edx, exeptr
      xor eax, eax                  ;<---- Addres of first API is at [edx]
  find_api:
      mov ecx, [edx]                       ;<---- If NULL end of imports from this dll
      cmp ecx, NULL                              ;<---- and go to the next =)
      jz @F
      mov esi, [edx]
      add esi, 2
      add esi, exeptr               ;<---- API name !!!!!
      push edx
      push eax
      invoke GetProcAddress, dllHandle, esi     ;<---- Get Address of API and store it
      mov api, eax
      pop eax
      pop edx
      
      mov ecx, [ebx].FirstThunk
      add ecx, exeptr
      mov edi, api
      mov [ecx+eax*4], edi           ;<----- Save API address at IAT
      add edx, 4
      inc eax
      jmp find_api
   @@:                               ;<----- go to the next image_descriptor
      add ebx, sizeof IMAGE_IMPORT_DESCRIPTOR
      cmp [ebx].Name1, NULL          ;<----- if dll name is 0 no more imports
      jz done
      jmp fill_import 
      
   done:  
  ret
import ENDP

do_relocation PROC reloc_P:DWORD
    LOCAL relocation:DWORD
    mov eax, exeptr
    mov ecx, nthdr.OptionalHeader.ImageBase
    sub eax, ecx
    mov relocation, eax
    
    mov ebx, reloc_P
    ASSUME ebx : ptr IMAGE_BASE_RELOCATION
    @relocs: 
      mov ecx, [ebx].SizeOfBlock
      sub ecx, 8               ;<---- chunsize - sizeof IMAGE_RELOC which is 8
      shr ecx, 1               ;<---- divide by 1^2 aka 2 
    
      mov edx, [ebx].VirtualAddress
      add edx, exeptr          ;<---- here is base for this allocation!!!!
    @@:                      ;<---- ecx holds number of relocations
      mov edi, edx
      xor eax, eax
      mov ax, word ptr[ebx+8+ecx*2-2]   ;<---- starts from last chunk
                                        ;<---- Assume that all chunks are relocateable
                                        ; ecx is one step ahead so we need -2 =))
                                        ;<---- is this 3 or 0?!?!?!
      push edx
      xor edx, edx
      mov dx, ax
      shr dx, 12         
      cmp edx, 0
      jz @skip                         ;<--- if 0 skip relocation job                                           
       and ax, 0FFFh                     
       add edi, eax                      ;<---- here should be first relocation!!!
       mov eax, [edi]                    ;<---- get that value
       add eax, relocation               ;<---- do relocation
       stosd                             ;<---- put relocataed value back!!!
      @skip:
     pop edx                           ;<---- restore edx
     loop @B                                               
    add ebx, [ebx].SizeOfBlock
    cmp [ebx].VirtualAddress, NULL      ;<---- end of relocation???
    jnz   @relocs
   ret
do_relocation ENDP                    
      
END start     